/* Problem URL: https://codeforces.com/gym/100886/problem/G */

#include <bits/stdc++.h>

using namespace std;
#define V vector
#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    string tmp, b;
    cin >> tmp >> b;

    size_t diff = b.size() - tmp.size();

    string a;
    rep(i, diff) {
        a.push_back('0');
    }

    a += tmp;

    rep(i, a.size()) {
        if (a[i] != b[i]) {
            break;
        }

        if (a[i] == '0') {
            cout << b << '\n';
            return 0;
        }
    }

    vvvvl memo(a.size(), vvvl(2, vvl(2, vl(2, -1))));

    function<ll(int, int, int, int)> dp = [&](int i, int over, int under, int started) -> ll {
        if (i >= a.size()) {
            return 1;
        }

        ll &ans = memo[i][over][under][started];
        if (ans != -1) {
            return ans;
        }

        ans = 0;

        char limit = over ? '0' : a[i];
        for (int j = under ? '9' : b[i]; j >= limit; j--) {
            rmax(ans, dp(i + 1, over || j > a[i], under || j < b[i], started || j != '0') * (!started && j == '0' ? 1 : j - '0'));
        }

        return ans;
    };

    ll res = dp(0, 0, 0, 0);

    string ans;
    function<void(int, int, int, int, ll)> recover = [&](int i, int over, int under, int started, ll prod) {
        if (i >= a.size() - 1) {
            ans.push_back(prod + '0');
            return;
        }

        char limit = over ? '0' : a[i];
        for (int j = under ? '9' : b[i]; j >= limit; j--) {
            ll div = !started && j == '0' ? 1 : j - '0';

            if (prod % div == 0 && memo[i + 1][over || j > a[i]][under || j < b[i]][started || j != '0'] == prod / div) {
                ans.push_back(j);
                recover(i + 1, over || j > a[i], under || j < b[i], started || j != '0', prod / div);
                return;
            }
        }
    };

    recover(0, 0, 0, 0, res);

    cout << stoll(ans) << '\n';
}
